<?php
/**
* Plugin Name: Quote For Woocommerce Lite
* Plugin URI: https://wpexperts.io/products/woo-add-to-quote/
* Description: This Plugin adds woocommerce add to quote functionality and much more...
* Version: 1.4.9
* Tested up to: 6.0
* Author: wpexperts.io
* Author URI: https://quotewoo.com/
*/
define('WATQ_PLUGIN_URL',plugin_dir_url( __FILE__ ) );
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
if ( ! function_exists( 'wq_fs' ) ) {
    // Create a helper function for easy SDK access.
    function wq_fs() {
        global $wq_fs;

        if ( ! isset( $wq_fs ) ) {
            // Include Freemius SDK.
            require_once dirname(__FILE__) . '/freemius/start.php';

            $wq_fs = fs_dynamic_init( array(
                'id'                  => '8991',
                'slug'                => 'wc-quote',
                'type'                => 'plugin',
                'public_key'          => 'pk_aa699f16558fb26bc0b09206c44c1',
                'is_premium'          => false,
                'has_addons'          => false,
                'has_paid_plans'      => false,
                'menu'                => array(
                    'slug'           => 'wc-quote',
                    'first-path'     => 'admin.php?page=wc-settings&tab=watq_quote',
                    'account'        => false,
                    'support'        => false,
                ),
            ) );
        }

        return $wq_fs;
    }

    // Init Freemius.
    wq_fs();
    // Signal that SDK was initiated.
    do_action( 'wq_fs_loaded' );
}
/**
 * Check if WooCommerce is active
 **/
function watq_check_if_woo_is_active(){
	if ( !in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
		deactivate_plugins( plugin_basename( __FILE__ ) );
		$class = "error";
		$message = __("Quote plugin requires Woocommerce plugin to be activated.", 'watq');
		echo"<div class=\"$class\"> <p>$message</p></div>";
	}
}
add_action('admin_init','watq_check_if_woo_is_active');
function watq_load_functions() {
	if ( class_exists('WooCommerce') ) {
		require_once('functions.php');
	}
}
add_action( 'plugins_loaded', 'watq_load_functions' );
